#ifndef ELM_ATSPI_APP_OBJECT_EO_HH
#define ELM_ATSPI_APP_OBJECT_EO_HH
#include <Eo.h>

extern "C" {
#include "elm_atspi_app_object.eo.h"
#include "elm_interface_atspi_accessible.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "elm_interface_atspi_accessible.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace atspi { namespace app { 
struct Object;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::atspi::app::Object> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace atspi { namespace app { 
struct Object {
   static Eo_Class const* _eo_class()
   {
      return ELM_ATSPI_APP_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::atspi::app::Object() const;
   operator ::elm::atspi::app::Object&();
   operator ::elm::atspi::app::Object const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::elm::interface::Atspi_Accessible,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::elm::interface::Atspi_Accessible const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace elm { namespace atspi { namespace app { 
struct Object : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Accessible)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Object( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Object(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Object(Object const& other) = default;
   Object(Object&& other) = default;
   Object& operator=(Object const& other) = default;
   Object& operator=(Object&& other) = default;
   Object()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Object( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Object(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return ELM_ATSPI_APP_OBJECT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Object,  ::elm::interface::Atspi_Accessible,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Object const ,  ::elm::interface::Atspi_Accessible const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Object) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Object>::value, "");
} } } 
#include "elm_atspi_app_object.eo.impl.hh"
#endif
